﻿/********************************************************************************/
/* 	gamecore.d																	*/
/*------------------------------------------------------------------------------*/
/*	製作		D.K（あるふぁ～秘密基地）										*/
/*	製作開始	2008/05/22														*/
/*	MAIL		dk@red.interq.or.jp												*/
/*	URL			http://maglog.jp/alpha-secret-base/								*/
/*																				*/
/*	このソースは「やわらかライセンス」の元で配布されています。					*/
/*-更新履歴---------------------------------------------------------------------*/
/*	2008/05/22	初版															*/
/*-その他-----------------------------------------------------------------------*/
/*	なし																		*/
/********************************************************************************/

private import state;
private import hell2;
private import boot;
private import actor;
private import vector;
private import keypad;
private import clickable;
//private import configparser;

import config;

private import character;
private import map;
private import fmfloader;

//private import std.math;

/********************************************************************************/

//ConfigParser configparser = null;
const static string CONFIG_PATH = "config.ini";


/* GameMain *********************************************************************/
/*	ゲーム本体の状態															*/
/********************************************************************************/

class GameMain : GameState
{
public:
	//-----------------------------------------------------------------------------
	//システム制御用
	//-----------------------------------------------------------------------------
	enum SCENE{
		INIT = 0,
		START,
		MAIN,
		CLEAR,
		END,
		PAUSE,
		RELESE,
		
		//以下ゲーム内の演出
		PLAYER_WARP,
		ENEMY_GETWAIT,
		PLAYER_MISSWAIT,

		EXIT,
	};
	
	enum EVENT_CODE{
		START1_POS = 0,
		RESTART_POS,

		SCROLL_FREE = 16,
		SCROLL_RIGHT,
		SCROLL_LEFT,
		SCROLL_UP,
		SCROLL_DOWN,
		SCROLL_WAIT,
		SCROLL_WAIT_RIGHT,
		SCROLL_WAIT_LEFT,
		SCROLL_WAIT_UP,
		SCROLL_WAIT_DOWN,
		
		BG_SET = 32,
		
		ENEMY_SET = 48,
		BOSS = 64,
		NONE = 255,
	};

	enum SCROLL_STATUS{
		NONE = 0,
		SCROLL_FREE = 16,
		SCROLL_RIGHT,
		SCROLL_LEFT,
		SCROLL_UP,
		SCROLL_DOWN,
		SCROLL_WAIT,
		SCROLL_WAIT_RIGHT,
		SCROLL_WAIT_LEFT,
		SCROLL_WAIT_UP,
		SCROLL_WAIT_DOWN,
	};

	enum GROUND_TYPE{
		NONE = -1,
		GROUND = 0,
		AIR = 255,
	};
	
	enum PARAM_TYPE{
		NONE = 255,
	};

	enum REQEST_CODE{
		NONE = 0,
		REQEST_PLAYER_WARP_L,
		REQEST_PLAYER_WARP_R,
		REQEST_SCOER_UP_ITEMGET,
		REQEST_SCOER_COUNT_CLAER,
		REQEST_EFFECT1,
		REQEST_EFFECT2,
		REQEST_EFFECT3,
		REQEST_ENEMY_DEL,
		REQEST_POWER_UP,
		REQEST_ENEMY_CREATE,
		REQEST_SCOER_UP_ENEMYGET,
		REQEST_SCOER_UP_ITEM3GET,
		REQEST_ENEMY_GETWAIT,
		REQEST_SCOER_UP_NONSTOP,
	};


	ConfigParser savedata;			// セーブデータ
	ConfigParser hoshi_conf;		// 画像の設定ファイル
	int timer;						// 汎用タイマー
	SCENE iSceneStatus;				//画面の状態
	int stage;						// ステージ
	int stage_start_count;			// ステージ開始処理
	int stage_clear_count;			// ステージ開始処理
	
	Keypad keypad;					// キーボード/ゲームパッド取得用
	double view_point_x;			// 視点x(スクリーン座標系)
	double view_point_y;			// 視点y(スクリーン座標系)

	int RecestCode[512];
	int RecestCode_Pointer;

	SCROLL_STATUS scroll_status;		// スクロールステータス
	
	static const PLAYER_MAX = 1;
	static const CHARACTER_MAX = 512;
	Character character[CHARACTER_MAX];

	float mob_x[CHARACTER_MAX];
	int mob_type[CHARACTER_MAX];
	
	Layer2D layer1; // 地形奥
	Layer2D layer2; // 地形手前
	Layer2D layer3; // 地形判定
	Layer2D layer4; // イベント
	Layer2D layer5; // 背景
	Map map1; 		// 地形奥
	Map map2; 		// 地形手前
	
	Vec3 start_pos;	//開始地点 

	//-----------------------------------------------------------------------------
	//ゲーム別に使用される特別処理用変数
	//-----------------------------------------------------------------------------
	float player_warp_start = 0;	//ワープ演出開始時の角度
	float player_warp_counter = 0;	//ワープ演出時間
	int player_warp_houkou = 0;		//ワープ方向
	int game_time_count = 0;		//ゲーム終了までの残り時間
	int game_score = 0;				//スコア
	int game_score_count = 0;		//スコア倍率
	int game_score_item_count = 0;	//連続でアイテムを取得した数
	int game_score_mob_count = 0;	//背景オブジェクトの数
	int itemsetinfo[20];			//アイテムの配置情報
	int enemysetinfo[10];			//敵の配置情報
	float enemyset_counter = 0;		//敵配置までのカウンター
	int enemyset_num = 0;			//敵配置数
	int itemget = 0;				//プレイヤーがアイテムを取得した
	
	float map_rotate_speed = 0.5f;
	float map_rotate = 0;
	float map_size = 0;
	float game_speed = 0;

	float powerup_count = 0;
	float powerup_count_start_max = 0;		//パワーアップ開始時の時間の最大値
	float powerup_count_max = ( 60 * 5 );	//パワーアップ時間の最大値

	float disable_input_count = 0;	//プレイヤーの入力不可カウンタ
	int enemy_getwait_count = 0;	//敵を倒したときのWAITカウンタ
	int player_misswait_count = 0;	//ミスしたときのWAITカウンタ
	int enemy_get_count = 0;		//一回のパワーアップで倒した敵の数
	
	int menu_input = 0;				//敵を倒したときのWAITカウンタ
	int hi_score = 0;				//ハイスコア
	
	//レベルの内訳
	int bouns_item_get;
	int bouns_item3_get;
	int bouns_enemy_get;
	
	int replaymode;			//リプレイモード
	int screenshot = 0;		//スクリーンショットを作成する
	int select_star = 0;	//選ばれている星の種類
	int time_extend_mode = 0;	//タイムエクステンドモード
	int time_extend_count = 0;	//タイムエクステンド回数
	int arcade_mode = 0;	//アーケードモード
	int arcade_stage = 0;	//アーケードモード
	int bak_default = 0;		//差し替えフラグ
	int bgm_default = 0;
	int se_default = 0;
	int bak1_alpha = 0;
	int bak2_alpha = 0;
	int bak3_alpha = 0;

	//-----------------------------------------------------------------------------
	//	コンストラクタ
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	this()
	{
		setMsg( GameState.MSG_NONE );
		// 各種初期化
		timer = 0;
		savedata          = new ConfigParser();
		hoshi_conf        = new ConfigParser();
		
		view_point_x = 0;
		view_point_y = 0;

		map_rotate = 0;
		map_size = 0;
		map_rotate_speed = 0.5f;
		game_speed = 1.0f;
		stage_start_count = 0;
		stage_clear_count = 0;
		
		keypad = new Keypad();
		keypad.SetUseCancel( false );

		//シーンを初期化にする
		iSceneStatus = SCENE.INIT;
		scroll_status = SCROLL_STATUS.SCROLL_FREE;
		stage = 1;						// ステージ
		
		//ゲーム別に使用される特別処理用変数
		player_warp_counter = 0;
		game_time_count = ( 60 * 60 * 3 );		//ゲーム終了までの残り時間
//		game_time_count = ( 60 * 3 );		//ゲーム終了までの残り時間
		game_score = 0;				//スコア
		game_score_count = 0;		//スコア倍率
		itemget = 0;				//プレイヤーがアイテムを取得した
		powerup_count = 0;
		disable_input_count = 0;	//プレイヤーの入力不可カウンタ
		
		//レベルの内訳
		bouns_item_get = 0;
		bouns_item3_get = 0;
		bouns_enemy_get = 0;

		if ( Hell_GetGameflag( 2 ) == 1 )
		{
			time_extend_mode = 1;	//タイムエクステンドモード
		}
		arcade_stage = 0;	//アーケードモードステージ数
		if ( Hell_GetGameflag( 2 ) == 2 )
		{
			arcade_mode = 1;	//アーケードモード
			powerup_count_max = ( 60 * 5 );	//パワーアップ時間の最大値
			game_time_count = ( 60 * 120 );		//ゲーム終了までの残り時間 30秒
		}

		time_extend_count = 0;
		if ( time_extend_mode == 1 )
		{
			game_time_count = ( 60 * 120 );		//ゲーム終了までの残り時間 30秒
		}

	}

	
	//-----------------------------------------------------------------------------
	//	シーンの初期化
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void init( )
	{
		char[] str;

		Hell_stopBgm( 1000 );
		//セーブデータ
		try
		{
			savedata.load(CONFIG_PATH);
		}
		catch(Exception e)
		{
			savedata.set("HOSHI",         1);
			savedata.set("SELECT_HOSHI",         0);
			savedata.set("SELECT_MODE",         0);
			savedata.set("HI_SCORE",         0);
			savedata.set("HI_SCORE_TIME",         0);
			savedata.set("HI_SCORE_ARCADE",         0);
			savedata.write();
		}
		if ( time_extend_mode == 1 )
		{
			hi_score = savedata.getint("HI_SCORE_TIME");
		}
		else if ( arcade_mode == 1 )
		{
			hi_score = savedata.getint("HI_SCORE_ARCADE");
		}
		else 
		{
			hi_score = savedata.getint("HI_SCORE");
		}


		Hell_randSeedTime();

		int hoshino = 1;
		int hoshirand = Hell_GetGameflag( 1 );
		
		if ( hoshirand == 0 )
		{
			hoshino = savedata.getint("HOSHI");
			hoshirand = Hell_randInt( 1, hoshino + 1 );
		}
		select_star = hoshirand;	//選ばれている星の種類
		
		//リソースの読み込み
//		Hell_loadTexture("map1","resource/image/map/map1.bmp" , [0,255,0]);

		Hell_loadTexture("menu","resource/image/menu.bmp" , [0,255,0]);

		try
		{
			str = std.string.format( "resource/image/hoshi_%02d/change.txt", select_star );
			hoshi_conf.load(str);
		}
		catch(Exception e)
		{
			hoshi_conf.set("bak_default",         0);
			hoshi_conf.set("gbm_default",         0);
			hoshi_conf.set("se_default",         0);
			hoshi_conf.set("bak1_alpha_add",         0);
			hoshi_conf.set("bak2_alpha_add",         0);
			hoshi_conf.set("bak3_alpha_add",         0);
			hoshi_conf.write();
		}
		bak_default = hoshi_conf.getint("bak_default");
		bgm_default = hoshi_conf.getint("gbm_default");
		se_default = hoshi_conf.getint("se_default");
		bak1_alpha = hoshi_conf.getint("bak1_alpha_add");
		bak2_alpha = hoshi_conf.getint("bak2_alpha_add");
		bak3_alpha = hoshi_conf.getint("bak3_alpha_add");
			
			
		
		if ( se_default == 0 )
		{
			Hell_loadWAV("get",         "resource/sound/get.wav");
			Hell_loadWAV("door",        "resource/sound/door.wav");
			Hell_loadWAV("damage",        "resource/sound/damage.wav");
			Hell_loadWAV("select",        "resource/sound/select.wav");
			Hell_loadWAV("destroy",        "resource/sound/destroy.wav");
			Hell_loadWAV("powerup",        "resource/sound/powerup.wav");
		}
		else 
		{
/*
			Hell_loadWAV("get",         "resource/sound/get.wav");
			Hell_loadWAV("door",        "resource/sound/door.wav");
			Hell_loadWAV("damage",        "resource/sound/damage.wav");
			Hell_loadWAV("select",        "resource/sound/select.wav");
			Hell_loadWAV("destroy",        "resource/sound/destroy.wav");
			Hell_loadWAV("powerup",        "resource/sound/powerup.wav");
*/
			str = std.string.format( "resource/image/hoshi_%02d/get.wav", select_star );
			Hell_loadWAV("get",str);
			str = std.string.format( "resource/image/hoshi_%02d/door.wav", select_star );
			Hell_loadWAV("door",str);
			str = std.string.format( "resource/image/hoshi_%02d/damage.wav", select_star );
			Hell_loadWAV("damage",str);
			str = std.string.format( "resource/image/hoshi_%02d/select.wav", select_star );
			Hell_loadWAV("select",str);
			str = std.string.format( "resource/image/hoshi_%02d/destroy.wav", select_star );
			Hell_loadWAV("destroy",str);
			str = std.string.format( "resource/image/hoshi_%02d/powerup.wav", select_star );
			Hell_loadWAV("powerup",str);
		}
		

		str = std.string.format( "resource/image/hoshi_%02d/hoshi.bmp", select_star );
		Hell_loadTexture("hosi",str , [0,255,0]);
		str = std.string.format( "resource/image/hoshi_%02d/effect.bmp", select_star );
		Hell_loadTexture("effect",str , [0,255,0]);
		str = std.string.format( "resource/image/hoshi_%02d/e32.bmp", select_star );
		Hell_loadTexture("enemy",str , [0,255,0]);
		str = std.string.format( "resource/image/hoshi_%02d/char.bmp", select_star );
		Hell_loadTexture("char",str , [0,255,0]);
		str = std.string.format( "resource/image/hoshi_%02d/item.bmp", select_star );
		Hell_loadTexture("item",str , [0,255,0]);

		//背景画像の設定ファイルを読み込み
		if ( bak_default == 0 )
		{
			Hell_loadTexture("ana","resource/image/bak/ana.bmp" , [0,255,0]);
			Hell_loadTexture("sora1","resource/image/bak/sora1.bmp" , [0,255,0]);
			Hell_loadTexture("sora2","resource/image/bak/sora2.bmp" , [0,255,0]);
			Hell_loadTexture("sora3","resource/image/bak/sora3.bmp" , [0,255,0]);
			Hell_loadTexture("sora4","resource/image/bak/sora4.bmp" , [0,255,0]);
		}
		else 
		{
			str = std.string.format( "resource/image/hoshi_%02d/ana.bmp", select_star );
			Hell_loadTexture("ana",str , [0,255,0]);
			str = std.string.format( "resource/image/hoshi_%02d/sora1.bmp", select_star );
			Hell_loadTexture("sora1",str , [0,255,0]);
			str = std.string.format( "resource/image/hoshi_%02d/sora2.bmp", select_star );
			Hell_loadTexture("sora2",str , [0,255,0]);
			str = std.string.format( "resource/image/hoshi_%02d/sora3.bmp", select_star );
			Hell_loadTexture("sora3",str , [0,255,0]);
			str = std.string.format( "resource/image/hoshi_%02d/sora4.bmp", select_star );
			Hell_loadTexture("sora4",str , [0,255,0]);
		}


		Hell_randSeed( 757, 3 );
		
		//キャラクタの生成
		loadFMF("data\\stage\\1\\1.fmf");
		map1 = new Map();
		map1.init( this, layer1 );
		map1.set_param( 1 );	//レイヤー１
		map2 = new Map();
		map2.init( this, layer2 );
		map2.set_param( 2 );	//レイヤー２
		
		start_pos = new Vec3( );	//開始地点 
		set_object( );
		
		int i;
		int item_pos;
		int charidx;
		item_pos = getMapWidth( ) / 4;
		SetCharacter( new Vec3( 0, 3136, 0 ), cast( int )Character.CHRTYPE.PLAYER1 );

		//ケーキアイテムの配置
		for ( i = 1; i < 4; i++ )
		{
			charidx = SetCharacter( new Vec3( item_pos * ( i ), 3136, 0 ), cast( int )Character.CHRTYPE.ITEM1 );
			if ( ( charidx != -1 ) )
			{
				itemsetinfo[i - 1] = charidx;	//バッファポインタ
				itemsetinfo[i - 1 + 5] = i;		//位置
				itemsetinfo[i - 1 + 10] = i - 1;		//位置
				character[charidx].set_param( i - 1 );	//パラメータの追加
			}
		}
		//ドアアイテムの配置
		for ( i = 0; i < 4; i++ )
		{
			charidx = SetCharacter( new Vec3( ( item_pos * ( i ) ) + ( item_pos / 2 ), 3136, 0 ), cast( int )Character.CHRTYPE.ITEM2 );
			if ( ( charidx != -1 ) )
			{
				character[charidx].set_param( i % 2 );	//パラメータの追加
			}
		}
		for ( i = 0; i < 4; i++ )
		{
			enemysetinfo[i] = 0;	//アイテムの配置情報
			enemysetinfo[i+5] = 0;	//アイテムの配置情報
		}
		enemyset_counter = 60;		//敵配置までのカウンター
		enemyset_num = 3;			//敵配置数

		//キャラクタの表示状態を初期化（他のゲームではいらないかも）
/*
//		character_freamStart( );
		map1.move( );
		mob_move( );
//		character_move( Character.CHRTYPE.PLAYER1 );
//		character_move( Character.CHRTYPE.PLAYER2 );
		enemy_move( );
		item_move( );
		event_move( );
		map2.move( );
		effect_move( );
//		world_move( );

//		character_freamEnd( );
*/
		iSceneStatus = SCENE.START;
		replaymode = Hell_GetGameflag( 0 );	//リプレイモード
		if ( replaymode != 0 )
		{
			//リプレイを再生する
			try
			{
				if ( time_extend_mode == 1 )
				{
					keypad.load( "replay/replay_02.bin" );
				}
				else if ( arcade_mode == 1 )
				{
					keypad.load( "replay/replay_03.bin" );
				}
				else 
				{
					keypad.load( "replay/replay_01.bin" );
				}
			}
			catch(Exception e)
			{
				//ファイルのオープンに失敗した
				iSceneStatus = SCENE.EXIT;
			}
		}
	}
	

	//-----------------------------------------------------------------------------
	//	マップ情報からオブジェクトの生成
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void set_object( )
	{
		int j = 0;
		int i = 0;
		
		for( i = 0; i < CHARACTER_MAX; i++ )
		{
			character[i] = new Character( );
		}
		
		
		for( j = 0; j < layer1.height; j++ )
		{
			for( i = 0; i < layer1.width; i++ )
			{
				int id = layer4.get( i, j );
				int id2 = layer5.get( i, j );
				int charidx = -1;
				switch ( cast( EVENT_CODE )id )
				{
				case EVENT_CODE.START1_POS:
					//プレイヤーの配置
					SetCharacter( new Vec3( i * layer4.chip_width, j * layer4.chip_height, 0 ), cast( int )Character.CHRTYPE.PLAYER1 );
					break;
				case EVENT_CODE.SCROLL_FREE:
					SetCharacter( new Vec3( i * layer4.chip_width, j * layer4.chip_height, 0 ), cast( int )Character.CHRTYPE.SCROLL_FREE );
					break;
				case EVENT_CODE.SCROLL_RIGHT:
					SetCharacter( new Vec3( i * layer4.chip_width, j * layer4.chip_height, 0 ), cast( int )Character.CHRTYPE.SCROLL_RIGHT );
					break;
				case EVENT_CODE.SCROLL_LEFT:
					SetCharacter( new Vec3( i * layer4.chip_width, j * layer4.chip_height, 0 ), cast( int )Character.CHRTYPE.SCROLL_LEFT );
					break;
				case EVENT_CODE.SCROLL_UP:
					SetCharacter( new Vec3( i * layer4.chip_width, j * layer4.chip_height, 0 ), cast( int )Character.CHRTYPE.SCROLL_UP );
					break;
				case EVENT_CODE.SCROLL_DOWN:
					SetCharacter( new Vec3( i * layer4.chip_width, j * layer4.chip_height, 0 ), cast( int )Character.CHRTYPE.SCROLL_DOWN );
					break;
				case EVENT_CODE.SCROLL_WAIT:
					SetCharacter( new Vec3( i * layer4.chip_width, j * layer4.chip_height, 0 ), cast( int )Character.CHRTYPE.SCROLL_WAIT );
					break;
				case EVENT_CODE.BG_SET:
					charidx = SetCharacter( new Vec3( i * layer4.chip_width, j * layer4.chip_height, 0 ), cast( int )Character.CHRTYPE.BG_SET );
					if ( ( id2 != PARAM_TYPE.NONE ) && ( charidx != -1 ) )
					{
						character[charidx].set_param( id2 );	//パラメータの追加
					}
					break;
				default:
					break;
				}
			}
		}
	}


	//-----------------------------------------------------------------------------
	//	FMFファイルの読み込み
	//-----------------------------------------------------------------------------
	//	引	数: FNFファイルパス
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void loadFMF(char[] filepath)
	{
		scope fmf = new FMFLoader(filepath);
		layer1 = fmf.getLayer(0); // 地形奥
		layer2 = fmf.getLayer(1); // 地形手前
		layer3 = fmf.getLayer(2); // 地形判定
		layer4 = fmf.getLayer(3); // イベント
		layer5 = fmf.getLayer(4); // 背景
		for(int j = 0; j < layer1.height; j++)
		{
			for(int i = 0; i < layer1.width; i++)
			{
				int id = layer1.get(i, j);
			}
		}
//		Hell_write(layer1.width);
//		Hell_write(layer1.height);
//		Hell_write(layer1.chip_width);
//		Hell_write(layer1.chip_height);
	}

	//-----------------------------------------------------------------------------
	//	シーンの後処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void relese( )
	{
//		int i;
//		for( i = 0; i < CHARACTER_MAX; i++ )
//		{
//			character[i].destroy( );
//		}
		iSceneStatus = SCENE.EXIT;
	}
	//-----------------------------------------------------------------------------
	//	開始演出
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneStart_move( )
	{
		int i;
		char[] str;
		
		map1.setMapRotate( map_rotate );
		map1.setMapSize( map_size );
		map1.setGameSpeed( game_speed );
		map2.setMapRotate( map_rotate );
		map2.setMapSize( map_size );
		map2.setGameSpeed( game_speed );
		for ( i = cast( int )Character.CHRTYPE.PLAYER1; i < cast( int )Character.CHRTYPE.MAX; i++ )
		{
			character_setrotate( i );
		}


		if ( stage_start_count < ( 60 * 1 ) )
		{
			stage_start_count++;
		}
		else 
		{
			if ( bgm_default == 0 )
			{
				Hell_playBgm( "resource/sound/bgm.ogg", -1, 0 );
			}
			else 
			{
				str = std.string.format( "resource/image/hoshi_%02d/bgm.ogg", select_star );
				Hell_playBgm( str, -1, 0 );
			}
			iSceneStatus = SCENE.MAIN;
			stage_start_count = 0;
		}
	}
	//-----------------------------------------------------------------------------
	//	ステージ開始表示処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneStart_draw( )
	{
		if ( stage_start_count > ( 60 * 2 ) )
		{
			Hell_drawFont(" GO! " , 240, 200 , 4 , 255,255,255);
		}
		else
		{
			Hell_drawFont("READY" , 240, 200 , 4 , 255,255,255);
		}
	}
	//-----------------------------------------------------------------------------
	//	クリア演出の処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneClear_move( )
	{
		screenshot = 0;		//スクリーンショットを作成する
		if ( stage_clear_count > ( 60 * 2 ) )
		{
			if( keypad.isPushEnter(true) )
			{
				iSceneStatus = SCENE.RELESE;
			}
			if( keypad.isPushCancel(true) )
			{
				screenshot = 1;		//スクリーンショットを作成する
			}
		}
		else 
		{
			stage_clear_count++;
		}
		
		
	}
	//-----------------------------------------------------------------------------
	//	クリア演出の表示
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneClear_draw( )
	{

		if ( screenshot == 1 )		//スクリーンショットを作成する
		{
			char[] str;
			str = std.string.format( "Star_%02d.bmp", select_star );
			Hell_SaveBMP( str );
		}
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		Hell_drawFont( "HI SCORE" , 400, 10 , 2 , 255,255,255);
		Hell_drawFont( std.string.toString( hi_score ) , 400, 30 , 4 , 255,255,255);

		Hell_drawFont( "RESULTS" , 200, 70 , 4 , 255,255,255);


		Hell_drawFont( "ITEM GET" ,       210, 120 , 2 , 200,200,255);
		Hell_drawFont( std.string.toString( bouns_item_get ) ,  220, 140 , 4 , 200,200,255);

		Hell_drawFont( "NON STOP RUN" , 210, 170 , 2 , 200,255,200);
		Hell_drawFont( std.string.toString( bouns_item3_get ) , 220, 190 , 4 , 200,255,200);

		Hell_drawFont( "ENEMY GET" ,      210, 220 , 2 , 255,200,200);
		Hell_drawFont( std.string.toString( bouns_enemy_get ) , 220, 240 , 4 , 255,200,200);
		
		Hell_drawFont( "BUILDING BONUS" ,      210, 270 , 2 , 230,230,230);
		Hell_drawFont( std.string.toString( game_score_mob_count * 1000 ) , 220, 290 , 4 , 230,230,230);

		Hell_drawFont( "TOTAL SCORE" ,    210, 340 , 2 , 255,255,255);
		Hell_drawFont( std.string.toString( game_score ) , 220, 360 , 4 , 255,255,255);
		if ( hi_score <= game_score )
		{
			Hell_drawFont( "NEW RECORD !",170, 390 , 4 , 255,255,255);
		}
		if ( replaymode != 0 )
		{
			Hell_drawFont( "REPLAY" , 530, 460 , 2 , 255,255,255);
		}
		if ( time_extend_mode == 1 )
		{
			Hell_drawFont( "ITEM EXTEND MODE" , 10, 10 , 2 , 255,255,255);
		}
		else if ( arcade_mode == 1 )
		{
			Hell_drawFont( "ENEMY EXTENDE MODE" , 10, 10 , 2 , 255,255,255);
		}
		else 
		{
		}

		if ( stage_clear_count > ( 60 * 2 ) )
		{
			Hell_drawFont("PRESS X OR 2 BUTTON TO SCREEN SAVE" , 40, 420 , 2 , 255,255,255);
			Hell_drawFont("PRESS Z OR 1 BUTTON TO TITLE" , 100, 440 , 2 , 255,255,255);
		}
		else
		{
			Hell_drawFont(" TIME UP !" , 200, 420 , 4 , 255,255,255);
		}
	}
	//-----------------------------------------------------------------------------
	//	ゲームオーバー演出
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneEnd( )
	{
//		iSceneStatus = SCENE.MAIN;
	}
	
	//-----------------------------------------------------------------------------
	//	オブジェクトの動作
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void move()
	{
		
		switch( iSceneStatus )
		{
		case SCENE.INIT:
			//初期化
			init( );
			break;
		case SCENE.START:
			//開始
			SeneStart_move( );
			break;
		case SCENE.MAIN:
			keypad.update( );	//リプレイキー入力の更新
			//メイン
			character_freamStart( );

			map1.move( );
			mob_move( );
			map2.move( );
			character_move( Character.CHRTYPE.PLAYER1 );
//			character_move( Character.CHRTYPE.PLAYER2 );
			enemy_move( );
			item_move( );
			event_move( );
			effect_move( );
			
			
			//当たり判定
			Collision( Character.CHRTYPE.PLAYER_START, Character.CHRTYPE.PLAYER_END , Character.CHRTYPE.ITEM_START, Character.CHRTYPE.ITEM_END );
			Collision( Character.CHRTYPE.PLAYER_START, Character.CHRTYPE.PLAYER_END , Character.CHRTYPE.ENEMY_START, Character.CHRTYPE.ENEMY_END );

			world_move( );

			character_freamEnd( );

			system_move( );

			break;
		case SCENE.CLEAR:
			//クリア
			effect_move( );
			mob_move( );
			SeneClear_move( );
			break;
		case SCENE.END:
			//ゲームオーバー
			break;
		case SCENE.PAUSE:
			//一時停止
			pause_move( );
			break;
		case SCENE.RELESE:
			//後処理
			relese( );
			break;
			
		//以下ゲーム別の特別な演出
		case SCENE.PLAYER_WARP:
			//プレイヤーワープ
			effect_move( );
			player_warp_proc( );
			break;
		case SCENE.ENEMY_GETWAIT:
			//敵を倒した時のウェイト
			effect_move( );
			enemy_getwait_proc( );
			break;
		case SCENE.PLAYER_MISSWAIT:
			//プレイヤーがミスを倒した時のウェイト
			mob_move( );
			effect_move( );
			player_misswait_proc( );
			system_move( );
			break;

		case SCENE.EXIT:
		default:
			//シーンの終了
			setMsg(GameState.MSG_REQ_TITLE);
			break;
		}
		
		//カメラの位置を設定
		set_view( );
		
	}
	
	//-----------------------------------------------------------------------------
	//	オブジェクトの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void draw()
	{
		// 作画開始
		Hell_begin();
		resetPerspective();
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		
		switch( iSceneStatus )
		{
		case SCENE.INIT:
			//初期化
			break;
		case SCENE.START:
			//開始
			map1.draw( );
			mob_draw( );
			map2.draw( );
			event_draw( );
			item_draw( );
			character_draw( Character.CHRTYPE.PLAYER1 );
//			character_draw( Character.CHRTYPE.PLAYER2 );
			enemy_draw( );
			effect_draw( );
			system_draw( );

			SeneStart_draw( );
			break;
		case SCENE.MAIN:
			//メイン
			map1.draw( );
			mob_draw( );
			map2.draw( );
			event_draw( );
			item_draw( );
			character_draw( Character.CHRTYPE.PLAYER1 );
//			character_draw( Character.CHRTYPE.PLAYER2 );
			enemy_draw( );
			effect_draw( );
			system_draw( );
			break;
		case SCENE.CLEAR:
			//クリア
			map1.draw( );
			mob_draw( );
			map2.draw( );
			item_draw( );
			event_draw( );
			character_draw( Character.CHRTYPE.PLAYER1 );
//			character_draw( Character.CHRTYPE.PLAYER2 );
			enemy_draw( );
			effect_draw( );
//			system_draw( );
			SeneClear_draw( );
			break;
		case SCENE.END:
			//ゲームーバー
			map1.draw( );
			mob_draw( );
			map2.draw( );
			item_draw( );
			event_draw( );
			character_draw( Character.CHRTYPE.PLAYER1 );
//			character_draw( Character.CHRTYPE.PLAYER2 );
			enemy_draw( );
			effect_draw( );
//			system_draw( );
			SeneEnd( );
			break;
		case SCENE.PAUSE:
			//一時停止
			map1.draw( );
			mob_draw( );
			map2.draw( );
			item_draw( );
			event_draw( );
			character_draw( Character.CHRTYPE.PLAYER1 );
//			character_draw( Character.CHRTYPE.PLAYER2 );
			enemy_draw( );
			effect_draw( );
			system_draw( );
			pause_draw( );
			break;
		case SCENE.RELESE:
			//後処理
			break;
			
		//以下ゲーム別の特別な演出
		case SCENE.PLAYER_WARP:
			//プレイヤーワープ
			map1.draw( );
			mob_draw( );
			map2.draw( );
			item_draw( );
			event_draw( );
			character_draw( Character.CHRTYPE.PLAYER1 );
//			character_draw( Character.CHRTYPE.PLAYER2 );
			enemy_draw( );
			effect_draw( );
			system_draw( );
			break;
		case SCENE.ENEMY_GETWAIT:
			//プレイヤーワープ
			map1.draw( );
			mob_draw( );
			map2.draw( );
			item_draw( );
			event_draw( );
			character_draw( Character.CHRTYPE.PLAYER1 );
//			character_draw( Character.CHRTYPE.PLAYER2 );
			enemy_draw( );
			effect_draw( );
			system_draw( );
			break;
		case SCENE.PLAYER_MISSWAIT:
			//プレイヤーワープ
			map1.draw( );
			mob_draw( );
			map2.draw( );
			item_draw( );
			event_draw( );
			character_draw( Character.CHRTYPE.PLAYER1 );
//			character_draw( Character.CHRTYPE.PLAYER2 );
			enemy_draw( );
			effect_draw( );
			system_draw( );
			break;
			
		case SCENE.EXIT:
		default:
			break;
		}
// for debug code start
Hell_drawFPS( 550, 10 );
//Hell_drawFont( std.string.toString( cast( int )scroll_status ), 10, 10 * 1, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )position.y ), 10, 10 * 2, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )place ), 10, 10 * 3, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )motion ), 10, 10 * 4, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )debug_disp[0] ), 10, 10 * 5, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )jump_fream_count ), 10, 10 * 6, 1 , 255,255,255 );
// for debug code end

	}
	
	// 画面サイズ取得
	int getScreenWidth(){return boot.g_width;}
	int getScreenHeight(){return boot.g_height;}
	
	string zfill(string str , int n)
	{
		for(int t=str.length;t<n;t++){
			str = "0" ~ str;
		}
		return str;
	}

	// マップサイズ取得
	int getMapWidth(){return ( 1438 );}
	int getMapHeight(){return ( layer3.height * layer3.chip_height );}
	//チップサイズの取得
	int getMapChipWidth(){return ( layer3.chip_width );}
	int getMapChipHeight(){return ( layer3.chip_height );}
	
	//-----------------------------------------------------------------------------
	//	カメラの位置を設定
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void set_view( )
	{
		Vec3 pos;
		Vec3 pos1;
		Vec3 pos2;
		
		int i;
		for ( i = 0; i < CHARACTER_MAX; i++ )
		{
			switch( character[i].type )
			{
			case ( Character.CHRTYPE.PLAYER1 ):
				pos1 = character[i].getPosition( );
				break;
			case ( Character.CHRTYPE.PLAYER2 ):
				if ( PLAYER_MAX == 2 )
				{
					pos2 = character[i].getPosition( );
				}
				break;
			default:
				break;
			}
		}
		
		pos = new Vec3( );
		if ( PLAYER_MAX == 2 )
		{
			pos.x = ( ( pos1.x - pos2.x ) / 2 ) + pos1.x;
			pos.y = ( ( pos1.y - pos2.y ) / 2 ) + pos1.y;
		}
		else 
		{
			pos.x = pos1.x;
			pos.y = pos1.y;
		}

		switch( scroll_status )
		{
		case SCROLL_STATUS.SCROLL_FREE:
			//全方向スクール
			view_point_x = pos.x - ( getScreenWidth( ) / 2 );
			view_point_y = pos.y - ( getScreenHeight( ) / 2 );
			break;
		case SCROLL_STATUS.SCROLL_RIGHT:	
			//右方向スクール
			if ( pos.x > ( view_point_x + ( getScreenWidth( ) / 2 ) ) )
			{
				view_point_x = pos.x - ( getScreenWidth( ) / 2 );
			}
			break;
		case SCROLL_STATUS.SCROLL_LEFT:
			//左方向スクール
			if ( pos.x < ( view_point_x + ( getScreenWidth( ) / 2 ) ) )
			{
				view_point_x = pos.x - ( getScreenWidth( ) / 2 );
			}
			break;
		case SCROLL_STATUS.SCROLL_UP:
			//上方向スクール
			if ( pos.y < ( view_point_y + ( getScreenHeight( ) / 2 ) ) )
			{
				view_point_y = pos.y - ( getScreenHeight( ) / 2 );
			}
			break;
		case SCROLL_STATUS.SCROLL_DOWN:
			//下方向スクール
			if ( pos.y > ( view_point_y + ( getScreenHeight( ) / 2 ) ) )
			{
				view_point_y = pos.y - ( getScreenHeight( ) / 2 );
			}
			break;
		case SCROLL_STATUS.SCROLL_WAIT:
			//方向スクールしない
			break;
		case SCROLL_STATUS.SCROLL_WAIT_RIGHT:
			//右一画面固定スクロール
			break;
		case SCROLL_STATUS.SCROLL_WAIT_LEFT:
			//左一画面固定スクロール
			break;
		case SCROLL_STATUS.SCROLL_WAIT_UP:
			//上一画面固定スクロール
			break;
		case SCROLL_STATUS.SCROLL_WAIT_DOWN:
			//下一画面固定スクロール
			break;
		default:
			break;
		}

		
		//画面外にカメラは動かない
		if ( view_point_x < ( 0 - ( layer3.chip_width / 2 ) ) )
		{
			view_point_x = ( 0 - ( layer3.chip_width / 2 ) );
		}
		if ( view_point_x > ( ( layer3.width * layer3.chip_width ) - getScreenWidth( ) - ( layer3.chip_width / 2 ) ) ) 
		{
			view_point_x = ( ( layer3.width * layer3.chip_width ) - getScreenWidth( ) - ( layer3.chip_width / 2 ) );
		}
		if ( view_point_y < ( 0 - ( layer3.chip_height / 2 ) ) )
		{
			view_point_y = ( 0 - ( layer3.chip_height / 2 ) );
		}
		if ( view_point_y > ( ( layer3.height * layer3.chip_height ) - getScreenHeight( ) - ( layer3.chip_height / 2 ) ) ) 
		{
			view_point_y = ( ( layer3.height * layer3.chip_height ) - getScreenHeight( ) - ( layer3.chip_height / 2 ) );
		}

	}
	//-----------------------------------------------------------------------------
	//	スクロール方向の設定
	//-----------------------------------------------------------------------------
	//	引	数: status:スクロール方向
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void set_scroll_status( SCROLL_STATUS status )
	{
		scroll_status = status;
	}

	void world_move( )
	{
		int i;
		int ch_idx;
		Vec3 playpos;
		int movej;
		
		ch_idx = get_character_index( cast( int )Character.CHRTYPE.PLAYER1, 0 );
		if ( ch_idx != -1 )
		{
			movej = cast( int )character[ch_idx].move_buff[6];
		}
		if ( movej == 1 )	//プレイヤーが移動を行った
		{
	//		if ( ( map_rotate > 320 ) || ( map_rotate < 40 ) )
	//		{
				if(keypad.isPressLeft())
				{
					map_rotate = map_rotate - ( map_rotate_speed * game_speed );
					map_size = 0;
				}
				else if(keypad.isPressRight())
				{
					map_rotate = map_rotate + ( map_rotate_speed * game_speed );
					map_size = 0;
				}
	/*
			}
			else 
			{
				ch_idx = get_character_index( cast( int )Character.CHRTYPE.PLAYER1, 0 );
				if ( ch_idx != -1 )
				{
					float rot_scale_x;
					float rot_sa;
					playpos = character[ch_idx].getPosition( );

					rot_scale_x = ( playpos.x ) / cast( float )getMapWidth( );
					rot_scale_x = rot_scale_x * 360;

					rot_sa = rot_scale_x - ( map_rotate % 360 );
					map_rotate = map_rotate + rot_sa;
				}
			}
	*/	
		}
		map1.setMapRotate( map_rotate );
		map1.setMapSize( map_size );
		map1.setGameSpeed( game_speed );
		map2.setMapRotate( map_rotate );
		map2.setMapSize( map_size );
		map2.setGameSpeed( game_speed );

		for ( i = cast( int )Character.CHRTYPE.PLAYER1; i < cast( int )Character.CHRTYPE.MAX; i++ )
		{
			character_setrotate( i );
		}
		
		if ( powerup_count > 0 )
		{
			powerup_count = powerup_count - game_speed;
		}
		else 
		{
			enemy_get_count = 0;		//パワーアップ終了時にエネミーボーナスのクリア
			powerup_count = 0;
		}

	}
	
	//-----------------------------------------------------------------------------
	//	開始地点の設定
	//-----------------------------------------------------------------------------
	//	引	数: status:スクロール方向
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void set_start_pos( Vec3 pos )
	{
		start_pos = pos;
	}
	
	//-----------------------------------------------------------------------------
	//	座標がマップ外かを判定
	//-----------------------------------------------------------------------------
	//	引	数: int x：Ｘ座標
	//			int y：Ｙ座標
	//	戻り値: 0マップ内：、0以外マップ外
	//-----------------------------------------------------------------------------
	int is_mapout( int x, int y )
	{
		int rc = 0;
		
		//画面外にカメラは動かない
		if ( x < 0 )
		{
			rc = -1;
		}
		if ( x > ( ( layer3.width * layer3.chip_width ) - getScreenWidth( ) ) ) 
		{
			rc = -1;
		}
		if ( y < 0 )
		{
			rc = -1;
		}
		if ( y > ( ( layer3.height * layer3.chip_height ) - getScreenHeight( ) ) ) 
		{
			rc = -1;
		}
		
		return( rc );
		
	}
	
	//-----------------------------------------------------------------------------
	//	キャラクターに回転角度情報を設定
	//-----------------------------------------------------------------------------
	//	引	数: int chratype:表示するキャラクターのタイプ
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void character_setrotate( int chratype )
	{
		int i;
		Vec3 pos = new Vec3( 0, 0, 0 );
		
		for ( i = 0; i < CHARACTER_MAX; i++ )
		{
			switch( character[i].type )
			{
			case ( Character.CHRTYPE.PLAYER1 ):
				pos = character[i].getPosition( );
				break;
			default:
				break;
			}
		}

		for ( i = 0; i < CHARACTER_MAX; i++ )
		{
			if ( character[i].type == cast( Character.CHRTYPE )chratype )
			{
				character[i].setMapRotate( map_rotate );
				character[i].setMapSize( map_rotate );
				character[i].setPlayerPosition( pos );
				character[i].setGameSpeed( game_speed );
			}
		}
	}
	
	//-----------------------------------------------------------------------------
	//	キャラクターの動作
	//-----------------------------------------------------------------------------
	//	引	数: int chratype:表示するキャラクターのタイプ
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void character_move( int chratype )
	{
		int i;
		for ( i = 0; i < CHARACTER_MAX; i++ )
		{
			if ( character[i].type == cast( Character.CHRTYPE )chratype )
			{
				character[i].move( );
			}
		}
	}
	//-----------------------------------------------------------------------------
	//	キャラクターの削除
	//-----------------------------------------------------------------------------
	//	引	数: int chratype:削除するキャラクターのタイプ
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void character_destroy( int chratype )
	{
		int i;
		for ( i = 0; i < CHARACTER_MAX; i++ )
		{
			if ( character[i].type == cast( Character.CHRTYPE )chratype )
			{
				character[i].destroy( );
			}
		}
	}

	//-----------------------------------------------------------------------------
	//	敵の動作
	//-----------------------------------------------------------------------------
	//	引	数: int chratype:表示するキャラクターのタイプ
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void enemy_move( )
	{
		int i;

		enemyset_maneger( );
		
		for ( i = cast( int )Character.CHRTYPE.ENEMY_START; i < cast( int )Character.CHRTYPE.ENEMY_END; i++ )
		{
			character_move( cast( Character.CHRTYPE )i );
		}
	}
	//-----------------------------------------------------------------------------
	//	敵の描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void enemy_draw( )
	{
		int i;
		for ( i = cast( int )Character.CHRTYPE.ENEMY_START; i < cast( int )Character.CHRTYPE.ENEMY_END; i++ )
		{
			character_draw( cast( Character.CHRTYPE )i );
		}
	}
	//-----------------------------------------------------------------------------
	//	アイテムの動作
	//-----------------------------------------------------------------------------
	//	引	数: int chratype:表示するキャラクターのタイプ
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void item_move( )
	{
		int i;
		
		//アイテムの状態を監視しなければ配置
		itemset_maneger( );

		for ( i = cast( int )Character.CHRTYPE.ITEM_START; i < cast( int )Character.CHRTYPE.ITEM_END; i++ )
		{
			character_move( cast( Character.CHRTYPE )i );
		}
	}
	//-----------------------------------------------------------------------------
	//	アイテムの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void item_draw( )
	{
		int i;
		for ( i = cast( int )Character.CHRTYPE.ITEM_START; i < cast( int )Character.CHRTYPE.ITEM_END; i++ )
		{
			character_draw( cast( Character.CHRTYPE )i );
		}
	}

	//-----------------------------------------------------------------------------
	//	背景表示の設定
	//-----------------------------------------------------------------------------
	//	引	数: int disp:表示の有無　0：表示なし、1以上：ファイル名
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void set_bg( int disp )
	{
		if ( disp != 0 )
		{
			//リソースの読み込み
			Hell_loadTexture("bg","resource/image/bak/1.bmp" , [0,255,0]);
		}
		map1.set_bg( disp );
	}

	//-----------------------------------------------------------------------------
	//	プレイヤーの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void character_draw( int chratype )
	{
		int i;
		for ( i = 0; i < CHARACTER_MAX; i++ )
		{
			if ( character[i].type ==  cast( Character.CHRTYPE )chratype )
			{
				character[i].draw( );
			}
		}
	}
	
	
	//-----------------------------------------------------------------------------
	//	イベントの動作
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void event_move( )
	{
		int i;
		for ( i = cast( int )Character.CHRTYPE.EVENT_START; i < cast( int )Character.CHRTYPE.EVENT_END; i++ )
		{
			character_move( cast( Character.CHRTYPE )i );
		}
	}
	//-----------------------------------------------------------------------------
	//	イベントの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void event_draw( )
	{
		int i;
		for ( i = cast( int )Character.CHRTYPE.EVENT_START; i < cast( int )Character.CHRTYPE.EVENT_END; i++ )
		{
			character_draw( cast( Character.CHRTYPE )i );
		}
	}
	//-----------------------------------------------------------------------------
	//	エフェクトの動作
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void effect_move( )
	{
		int i;
		for ( i = cast( int )Character.CHRTYPE.EFFECT_START; i < cast( int )Character.CHRTYPE.EFFECT_END; i++ )
		{
			character_move( cast( Character.CHRTYPE )i );
		}
	}
	//-----------------------------------------------------------------------------
	//	エフェクトの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void effect_draw( )
	{
		int i;
		for ( i = cast( int )Character.CHRTYPE.EFFECT_START; i < cast( int )Character.CHRTYPE.EFFECT_END; i++ )
		{
			character_draw( cast( Character.CHRTYPE )i );
		}
	}
	//-----------------------------------------------------------------------------
	//	にぎやかしの動作
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void mob_move( )
	{
		int i;
		for ( i = cast( int )Character.CHRTYPE.MOB_START; i < cast( int )Character.CHRTYPE.MOB_END; i++ )
		{
			character_move( cast( Character.CHRTYPE )i );
		}
	}
	//-----------------------------------------------------------------------------
	//	にぎやかしの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void mob_draw( )
	{
		int i;
		for ( i = cast( int )Character.CHRTYPE.MOB_START; i < cast( int )Character.CHRTYPE.MOB_END; i++ )
		{
			character_draw( cast( Character.CHRTYPE )i );
		}
	}
	//-----------------------------------------------------------------------------
	//	ゲーム情報、システムの処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void system_move( )
	{
		//残り時間のカウント
		game_time_count--;
		if ( game_time_count <= 0 )
		{
			char[] str;
			
			if ( bgm_default == 0 )
			{
				Hell_playBgm( "resource/sound/results.ogg", -1, 0 );
			}
			else 
			{
				str = std.string.format( "resource/image/hoshi_%02d/results.ogg", select_star );
				Hell_playBgm( str, -1, 3000 );
			}
			iSceneStatus = SCENE.CLEAR;

			game_score = game_score + ( game_score_mob_count * 1000 );

			if ( replaymode == 0 )
			//リプレイではない
			{
				keypad.save( "replay/replay_tmp.bin" );	//リプレイの保存
				//ハイスコアの保存
				if ( hi_score < game_score )
				{
					if ( time_extend_mode == 1 )
					{
						keypad.save( "replay/replay_02.bin" );	//リプレイの保存
						hi_score = game_score;
						savedata.set("HI_SCORE_TIME",   cast(int)hi_score);
					}
					else if ( arcade_mode == 1 )
					{
						keypad.save( "replay/replay_03.bin" );	//リプレイの保存
						hi_score = game_score;
						savedata.set("HI_SCORE_ARCADE",   cast(int)hi_score);
					}
					else 
					{
						keypad.save( "replay/replay_01.bin" );	//リプレイの保存
						hi_score = game_score;
						savedata.set("HI_SCORE",   cast(int)hi_score);
					}
					savedata.write();
				}
			}
		}
		
		//回転を行う場合、現在の角度を保存
		if ( iSceneStatus == SCENE.PLAYER_WARP )
		{
			player_warp_start = map_rotate;	//回転演出開始時の角度を保存
		
		}
		//ゲームスピードの上昇
		if ( time_extend_mode == 1 )
		{
			game_speed = 1.0 + ( cast( float )game_score / 30000 );
			if ( game_speed > 2.0 )
			{
				game_speed = 2.0;
			} 
		}
/*
		else if ( arcade_mode == 1 )	//アーケードモード
		{
			game_speed = 1.0 + ( cast( float )game_score / 70000 );
			if ( game_speed > 3.0 )
			{
				game_speed = 3.0;
			} 
		}
*/
		else 
		{
			game_speed = 1.0 + ( cast( float )game_score / 50000 );
			if ( game_speed > 4.0 )
			{
				game_speed = 4.0;
			} 
		}

		if ( iSceneStatus == SCENE.MAIN )
		{
			if(keypad.isPushCancel(true))
			{
				//ポーズ
				iSceneStatus = SCENE.PAUSE;
				menu_input = 0;
			}
		}
	}
	//-----------------------------------------------------------------------------
	//	ゲーム情報、システムの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void system_draw( )
	{
		int min;
		int sec;
		char[] str;
		int r = 255;
		int g = 255;
		int b = 255;
		int fontsize;
		
		min = ( game_time_count / 60 ) / 60;
		sec = ( game_time_count / 60 ) % 60;
		
		if ( ( ( sec % 30 ) == 0 ) || ( ( sec < 30 ) && ( min == 0 ) ) )
		{
			r = 255;
			g = 128;
			b = 128;
		}
		
		str = std.string.format( "TIME %02d:%02d", min, sec );
		
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		Hell_drawFont( str , 200, 160 , 3 , r,g,b);

		fontsize = 4;
		if ( game_score > 999999 )
		{
			fontsize = 3;
		}
		Hell_drawFont( std.string.toString( game_score ) , 10, 30 , fontsize , 255,255,255);

		Hell_drawFont( "HI SCORE" , 400, 10 , 2 , 255,255,255);
		Hell_drawFont( std.string.toString( hi_score ) , 400, 30 , 4 , 255,255,255);
		if ( replaymode != 0 )
		{
			Hell_drawFont( "REPLAY" , 530, 460 , 2 , 255,255,255);
		}
		
		//パワーアップ時間の表示
		Hell_drawRect( 170 - 2, 190 - 2, 300 + 4, 10 + 4, 0, 0, 255, 255, 255, 255);
		Hell_drawRect( 170, 190, 300, 10, 0, 0, 0, 0, 0, 255);
		if ( cast( int )powerup_count > 0 )
		{
			float time = powerup_count;
			if ( time > 300.0f )
			{
				time = 300.0f;
			}
			Hell_drawRect( 170, 190, cast( int )time, 10, 0, 0, 0, 255, 0, 255);
		} 
		
		if ( time_extend_mode == 1 )
		{
			str = std.string.format( "EXTEND TO " );
			Hell_drawFont( str , 10, 70 , 2 , 255,255,255);
			str = std.string.format( "TIME %02d", 10 - ( game_score_item_count % 10 ) );
			Hell_drawFont( str , 10, 90 , 2 , 255,255,255);
		}

		if ( arcade_mode == 1 )
		{
			str = std.string.format( "EXTEND TO " );
			Hell_drawFont( str , 10, 70 , 2 , 255,255,255);
			str = std.string.format( "ENEMY %02d", 10 - ( time_extend_count ) );
			Hell_drawFont( str , 10, 90 , 2 , 255,255,255);
		}

		if ( time_extend_mode == 1 )
		{
			Hell_drawFont( "ITEM EXTEND MODE" , 10, 10 , 2 , 255,255,255);
		}
		else if ( arcade_mode == 1 )
		{
			Hell_drawFont( "ENEMY EXTEND MODE" , 10, 10 , 2 , 255,255,255);
		}
		else 
		{
			Hell_drawFont( "SCORE" , 10, 10 , 2 , 255,255,255);
		}
	}
	
	//-----------------------------------------------------------------------------
	//	キャラクタの生成
	//-----------------------------------------------------------------------------
	//	引	数: Vec3 pos:生成する位置
	//			int chratype:生成するキャラクターのタイプ
	//	戻り値: 生成したキャラクタのバッファ番号
	//-----------------------------------------------------------------------------
	int SetCharacter( Vec3 pos, int chratype )
	{
		int i;
		int rc = -1;
		for( i = 0; i < CHARACTER_MAX; i++ )
		{
			if ( character[i].exist == false )
			{
				character[i].init( this, pos, cast( Character.CHRTYPE )chratype );
				rc = i;
				break;
			}
		}

		return( rc );
	}
	//-----------------------------------------------------------------------------
	//	キャラクタの生成
	//-----------------------------------------------------------------------------
	//	引	数: Vec3 pos:生成する位置
	//			int chratype:生成するキャラクターのタイプ
	//			int param:パラメータ
	//	戻り値: 生成したキャラクタのバッファ番号
	//-----------------------------------------------------------------------------
	int SetCharacterEX( Vec3 pos, int chratype , int param )
	{
		int i;
		int rc = -1;
		for( i = 0; i < CHARACTER_MAX; i++ )
		{
			if ( character[i].exist == false )
			{
				character[i].init( this, pos, cast( Character.CHRTYPE )chratype );
				character[i].set_param( param );
				rc = i;
				break;
			}
		}
		
		if ( time_extend_mode == 1 )
		{
			if ( 
			     ( rc != -1 )
			  && ( cast( Character.CHRTYPE )chratype == Character.CHRTYPE.MOB1 )
			  && ( param < 5 )
			   )
			mob_find( rc, pos );
		}

		return( rc );
	}
	//-----------------------------------------------------------------------------
	//	ポーズの処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void pause_move( )
	{
		if(keypad.isPushUp(true))
		{
			Hell_playWAV( "select", 0, -1 );
			menu_input++;
			if ( menu_input > 1 )
			{
				menu_input = 0;
			}
		}
		else if(keypad.isPushDown(true))
		{
			Hell_playWAV( "select", 0, -1 );
			menu_input--;
			if ( menu_input < 0 )
			{
				menu_input = 1;
			}
		}
		if(keypad.isPushEnter(true))
		{
			switch ( menu_input )
			{
			case 0:
				//ポーズ解除
				iSceneStatus = SCENE.MAIN;
				break;
			case 1:
				//リトライ
				iSceneStatus = SCENE.RELESE;
				break;
			default:
				break;
			}
		}
		if(keypad.isPushCancel(true))
		{
			//ポーズ解除
			iSceneStatus = SCENE.MAIN;
		}
	}
	//-----------------------------------------------------------------------------
	//	ポーズの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void pause_draw( )
	{
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		Hell_drawTexture("menu"
			, 96 + 160
			, 64 + 120 + ( menu_input * 32 )
			, 320
			, 0
			, 32, 32
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
		Hell_drawTexture("menu"
			, 160
			, 120
			, 0
			, 0
			, 320, 240
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
	}
	
	//-----------------------------------------------------------------------------
	//	座標から地形判定レイヤーの値を取得
	//-----------------------------------------------------------------------------
	//	引	数: int x：座標x
	//			int y：座標y
	//	戻り値: 指定座標の地形レイヤーの値
	//-----------------------------------------------------------------------------
	int get_map_id( int x, int y )
	{
		int x2 = ( x + ( layer3.chip_width / 2 ) ) / layer3.chip_width;
		int y2 = ( y + ( layer3.chip_height / 2 ) ) / layer3.chip_height;
		int rc = layer3.get(x2, y2);
		
		return( rc );
	}
	
	
	//-----------------------------------------------------------------------------
	//	アイテムの状態を監視し、なければ生成する
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void itemset_maneger( )
	{
		int i;
		int j;
		int item_pos;
		int item_pos2;
		int charidx;
		int param;
		int posj[10];

		item_pos = getMapWidth( ) / 4;

		for ( i = 0; i < 10; i++ )
		{
			posj[i] = 0;
		}
		for ( i = 0; i < 3; i++ )
		{
			posj[itemsetinfo[i + 5]] = 1;
		}
		for ( i = 0; i < 4; i++ )
		{
			if ( posj[i] == 0 )
			{
				item_pos2 = i;
			}
		}
//Hell_write( "itemsetinfo[5]:%d\n", itemsetinfo[5] );
//Hell_write( "itemsetinfo[6]:%d\n", itemsetinfo[6] );
//Hell_write( "itemsetinfo[7]:%d\n", itemsetinfo[7] );
//Hell_write( "item_pos2:%d\n", item_pos2 );
		for( i = 0; i < 3; i++ )
		{
			if ( character[itemsetinfo[i]].move_buff[0] == 1 )
			{
				//オブジェクトは取得された
				//新しいアイテムを生成する
				param = itemsetinfo[i + 10];
				
				//配置場所をきめる
				//0から3までの４箇所で、自分をいた場所以外で開いている場所
//				charidx = SetCharacter( new Vec3( ( item_pos * ( item_pos2 ) ), 3136, 0 ), cast( int )Character.CHRTYPE.ITEM1 );
//Hell_write( "SetCharacter:%d\n", ( ( item_pos * ( item_pos2 ) ) + ( item_pos / 2 ) ) );

				character[itemsetinfo[i]].init( this, new Vec3( ( item_pos * ( item_pos2 ) ), 3136, 0 ), Character.CHRTYPE.ITEM1 );
				character[itemsetinfo[i]].set_param( param );	//パラメータの追加
//				itemsetinfo[i] = charidx;	//バッファポインタ
				itemsetinfo[i + 5] = item_pos2;
				SetCharacter( new Vec3( ( item_pos * ( item_pos2 ) ), 3136, 0 ), cast( int )Character.CHRTYPE.EFFECT1 );
				break;
			}
		}
	}
	
	//-----------------------------------------------------------------------------
	//	にぎやかしキャラクターの情報を設定
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void mob_info( )
	{
		int i;
		for( i = 0; i < CHARACTER_MAX ; i++ )
		{
			mob_x[i] = 0;
			mob_type[i] = -1;
			if ( character[i].exist == true )
			{
				if ( 
				     ( Character.CHRTYPE.MOB1 == character[i].type )
				   )
				{
					//情報の保存
					mob_x[i] = character[i].position.x;
					mob_type[i] = character[i].param;
				}
			}
		}
	}
	//-----------------------------------------------------------------------------
	//	にぎやかしキャラクターの情報を検索し別の建物に変換する
	//-----------------------------------------------------------------------------
	//	引	数: index：キャラクタバッファのインデックス
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void mob_find( int index, Vec3 pos )
	{
		int i;
		float find_x = character[index].position.x;
		int find_type = character[index].param;
		int count = 0;
		int chp1;
		int chp2;
		int chp3;
		int chgf = 0;

		mob_info( );
		
		//近くに建物があるかを検索する
		for( i = 0; i < CHARACTER_MAX ; i++ )
		{
			if ( mob_type[i] != -1 )
			{
				if ( 
				     ( ( find_x + 100 ) > mob_x[i] )
				  && ( ( find_x - 100 ) < mob_x[i] )
				  && ( find_type == mob_type[i] )
				  && ( i != index )
				   )
				{
					switch( count )
					{
					case 0:
						chp1 = i;
						chgf = 1;
						break;
					case 1:
						chp2 = i;
						break;
					case 2:
						chp3 = i;
						break;
					default:
						break;
					}
					count++;
				}
			}
		}
		//変換を行う
		if ( chgf != 0 )
		{
			mob_type[chp1] = -1;
//			mob_type[chp2] = -1;
			character[chp1].destroy( );
//			character[chp2].destroy( );
//			character[chp3].destroy( );
			character[index].destroy( );
			int charidx;
			charidx = SetCharacterEX( pos, cast( int )Character.CHRTYPE.MOB1, find_type + 1 );
		}
	}
	
	//-----------------------------------------------------------------------------
	//	アイテムの状態を監視し、なければ生成する
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void enemyset_maneger( )
	{
		int i;
		int j;
		int item_pos;
		int item_pos2;
		int charidx;
		int param;
		int posj[10];

		if ( enemyset_num > 0 )
		{
			if ( enemyset_counter > 0 )
			{
				enemyset_counter = enemyset_counter - ( 1 * game_speed );
			}
			else 
			{
				enemyset_num--;
				enemyset_counter = 60;
				charidx = SetCharacter( new Vec3( getMapWidth( ) / 2, 3136 + 170 , 0 ), cast( int )Character.CHRTYPE.ENEMY1 );
				if ( ( charidx != -1 ) )
				{
					character[charidx].set_param( enemyset_num );	//パラメータの追加
				}
				
			}
		}
		for( i = 0; i < 3; i++ )
		{
/*
			if ( character[enemysetinfo[i]].exist == false )
			{
				//オブジェクトは取得された
				//新しいアイテムを生成する
				param = character[enemysetinfo[i]].param;
				
				//配置場所をきめる
				//0から3までの４箇所で、自分をいた場所以外で開いている場所
				charidx = SetCharacter( new Vec3( getMapWidth( ) / 2, 3136 + 170 , 0 ), cast( int )Character.CHRTYPE.ENEMY1 );
//Hell_write( "SetCharacter:%d\n", ( ( item_pos * ( item_pos2 ) ) + ( item_pos / 2 ) ) );
				character[charidx].set_param( param );	//パラメータの追加
				enemysetinfo[i] = charidx;	//バッファポインタ
				enemysetinfo[i + 5] = item_pos2;
				SetCharacter( new Vec3( ( item_pos * ( item_pos2 ) ), 3136, 0 ), cast( int )Character.CHRTYPE.EFFECT1 );
				break;
			}
*/
/*
charidx = SetCharacter( new Vec3( getMapWidth( ) / 2, 3136 + 170 , 0 ), cast( int )Character.CHRTYPE.ENEMY1 );
if ( ( charidx != -1 ) )
{
	character[charidx].set_param( i );	//パラメータの追加
}
charidx = SetCharacter( new Vec3( getMapWidth( ) / 2, 3136 + 170 , 0 ), cast( int )Character.CHRTYPE.ENEMY1 );
*/
		}
	}

	//-----------------------------------------------------------------------------
	//	プレイヤーとアイテムの当たり判定を行う
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void Collision( int terget1_start, int terget1_end , int terget2_start, int terget2_end )
	{
		int i;
		int j;
		int ii;
		int jj;
		
		int char_index1;
		Vec3 pos1;
		int char_width1;
		int char_height1;
		
		int char_index2;
		Vec3 pos2;
		int char_width2;
		int char_height2;
		
		for ( i = terget1_start; i < terget1_end; i++ )
		{
			for( ii = 0; ii < CHARACTER_MAX; ii++ )
			{
				char_index1 = get_character_index( i, ii );
				if ( char_index1 == -1 )
				{
					break;
				}
				ii = char_index1;
				pos1 = character[char_index1].getPosition( );
				char_width1 = character[char_index1].get_width( );
				char_height1 = character[char_index1].get_height( );

//Hell_write( "Collision traget1 x:%d\n", cast( int )pos1.x );

				for ( j = terget2_start; j < terget2_end; j++ )
				{
					for( jj = 0; jj < CHARACTER_MAX; jj++ )
					{
						char_index2 = get_character_index( j, jj );
//Hell_write( "Collision traget2 char_index2 %d\n", cast( int )char_index2 );
						if ( char_index2 == -1 )
						{
							break;
						}
						jj = char_index2;
						pos2 = character[char_index2].getPosition( );
						char_width2 = character[char_index2].get_width( );
						char_height2 = character[char_index2].get_height( );
						
//Hell_write( "Collision traget2 x:%d\n", cast( int )pos2.x );
						//当たり判定
						if   (
						       ( ( pos1.x - ( char_width1 / 2 ) )  < ( pos2.x + ( char_width2 / 2 ) ) )
							&& ( ( pos2.x - ( char_width2 / 2 ) )  < ( pos1.x + ( char_width1 / 2 ) ) )
							&& ( ( pos1.y - ( char_height1 / 2 ) ) < ( pos2.y + ( char_height2 / 2 ) ) )
							&& ( ( pos2.y - ( char_height2 / 2 ) ) < ( pos1.y + ( char_height1 / 2 ) ) )
							 )
						{
//Hell_write( "Collision hit \n" );
							if ( character[char_index1].no_hit_count == 0 )
							{
								character[char_index1].hit( j, character[char_index2], 0 );
							}
							if ( character[char_index2].no_hit_count == 0 )
							{
								character[char_index2].hit( i, character[char_index1], 0 );
							}
						}
					}
				}
			}
		}
	}


	//-----------------------------------------------------------------------------
	//	キャラクターの位置を取得
	//-----------------------------------------------------------------------------
	//	引	数: int chratype:表示するキャラクターのタイプ
	//	戻り値: 位置情報
	//-----------------------------------------------------------------------------
	Vec3 get_character_pos( int chratype )
	{
		Vec3 rc_pos = new Vec3( 0, 0, 0 );
		int i;
		for ( i = 0; i < CHARACTER_MAX; i++ )
		{
			if ( character[i].type == cast( Character.CHRTYPE )chratype )
			{
				rc_pos = character[i].getPosition( );
			}
		}
		return( rc_pos );
	}
	//-----------------------------------------------------------------------------
	//	キャラクターのバッファを取得
	//-----------------------------------------------------------------------------
	//	引	数: int chratype:表示するキャラクターのタイプ
	//	引	数: int index_start:検索開始位置
	//	戻り値: 位置情報
	//-----------------------------------------------------------------------------
	int get_character_index( int chratype, int index_start )
	{
		int rc = -1;
		int i;
		for ( i = index_start; i < CHARACTER_MAX; i++ )
		{
			if ( character[i].type == cast( Character.CHRTYPE )chratype )
			{
				rc = i;
				break;
			}
		}
		
		return( rc );
	}
	//-----------------------------------------------------------------------------
	//	キャラクターの動作用バッファを設定
	//-----------------------------------------------------------------------------
	//	引	数: int chratype:表示するキャラクターのタイプ
	//			int buffindex:検索開始位置
	//			int param:検索開始位置
	//	戻り値: 位置情報
	//-----------------------------------------------------------------------------
	int set_character_buffer( int chratype, int buffindex, int param )
	{
		int rc = -1;
		int i;
		for ( i = 0; i < CHARACTER_MAX; i++ )
		{
			if ( character[i].type == cast( Character.CHRTYPE )chratype )
			{
				rc = 0;
				character[i].set_buffer( buffindex, param );
			}
		}
		
		return( rc );
	}
	//-----------------------------------------------------------------------------
	//	キャラクターのフレーム開始処理を実行
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void character_freamStart( )
	{
		int i;
		for ( i = 0; i < CHARACTER_MAX; i++ )
		{
			if ( character[i].type != Character.CHRTYPE.NONE )
			{
				character[i].freamStart( );
			}
		}

		itemget = 0;				//プレイヤーがアイテムを取得した
	}
	//-----------------------------------------------------------------------------
	//	キャラクターのフレーム終了処理を実行
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void character_freamEnd( )
	{
		int i;
		for ( i = 0; i < CHARACTER_MAX; i++ )
		{
			if ( character[i].type != Character.CHRTYPE.NONE )
			{
				character[i].freamEnd( );
			}
		}
	}
	//-----------------------------------------------------------------------------
	//	キャラクターからのリクエスト実行
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void character_reqest( int reqest_code, float x, float y, int type, int param1, int param2 )
	{
		int i;
		int charidx;
		switch( cast( REQEST_CODE )reqest_code )
		{
		case REQEST_CODE.REQEST_PLAYER_WARP_L:
		case REQEST_CODE.REQEST_PLAYER_WARP_R:
			//プレイヤーのワープ処理
			player_warp_counter = 60;
			
			iSceneStatus = SCENE.PLAYER_WARP;
			if ( cast( REQEST_CODE )reqest_code == REQEST_CODE.REQEST_PLAYER_WARP_L )
			{
				player_warp_houkou = 0;
			}
			else 
			{
				player_warp_houkou = 1;
			}
			break;
			
		case REQEST_CODE.REQEST_SCOER_UP_ITEMGET:
			//アイテムの取得
			//スコアの加算処理
			
			game_score_count++;
			if ( game_score_count > 10 )
			{
				game_score_count = 10;
			}
			game_score = game_score + ( game_score_count * 50 );
			bouns_item_get = bouns_item_get + ( game_score_count * 50 );
			itemget = 1;				//プレイヤーがアイテムを取得した
			
			
			game_score_item_count++;
			if ( ( game_score_item_count > 0 ) && ( ( game_score_item_count % 10 ) == 0 ) )
			{
				
				//10個とった
				game_score = game_score + ( ( game_score_item_count / 10 ) * 1000 );
				bouns_item3_get = bouns_item3_get + ( ( game_score_item_count / 10 ) * 1000 );

				//エフェクト3の生成
				charidx = CHARACTER_MAX - 1;
				character[charidx].init( this, new Vec3( x, y, 0 ), Character.CHRTYPE.EFFECT3 );
				character[charidx].set_param( ( ( game_score_item_count / 10 ) * 1000 ) );
				character[charidx].set_buffer( 2, 4 );

				//にぎやかしを配置
				game_score_mob_count++;
				if ( time_extend_mode == 1 )
				{
					SetCharacterEX( new Vec3( Hell_randInt( 0, getMapWidth( ) ), 3090, 0 ), cast( int )Character.CHRTYPE.MOB1, 0 );
				}
				else 
				{
					SetCharacterEX( new Vec3( Hell_randInt( 0, getMapWidth( ) ), 3090, 0 ), cast( int )Character.CHRTYPE.MOB1, 0 );
				}
				
				if ( time_extend_mode == 1 )
				{
					time_extend_count++;
					game_time_count = game_time_count + ( 60 * 15 );		//ゲーム終了までの残り時間 30秒
					//エフェクト3の生成
					charidx = CHARACTER_MAX - 1;
					character[charidx].init( this, new Vec3( x, y, 0 ), Character.CHRTYPE.EFFECT3 );
					character[charidx].set_param( 15 );
					character[charidx].set_buffer( 2, 5 );
				}

/*
				if ( arcade_mode == 1 )	//アーケードモード
				{
					arcade_stage++;			//ステージを進める
					if ( arcade_mode == 1 )	//アーケードモード
					{
						//ステージによってパワーアップの時間を変更する
						switch ( arcade_stage % 10 )
						{
						case 0:
							powerup_count_max = ( 60 * 10 );
							break;
						case 1:
							powerup_count_max = ( 60 * 10 );
							break;
						case 2:
							powerup_count_max = ( 60 * 7 );
							break;
						case 3:
							powerup_count_max = ( 60 * 7 );
							break;
						case 4:
							powerup_count_max = ( 60 * 15 );
							break;
						case 5:
							powerup_count_max = ( 60 * 15 );
							break;
						case 6:
							powerup_count_max = ( 60 * 7 );
							break;
						case 7:
							powerup_count_max = ( 60 * 7 );
							break;
						case 8:
							powerup_count_max = ( 60 * 20 );
							break;
						case 9:
							powerup_count_max = ( 60 * 20 );
							break;
						default:
							break;
						}
					}
				}
*/
				
			}
			else 
			{
				//エフェクト3の生成
				charidx = CHARACTER_MAX - 1;
				character[charidx].init( this, new Vec3( x, y, 0 ), Character.CHRTYPE.EFFECT3 );
				character[charidx].set_param( game_score_count * 50 );
				character[charidx].set_buffer( 2, 1 );
			}
			if ( ( game_score_item_count > 0 ) && ( ( game_score_item_count % 3 ) == 0 ) )
			{
				//にぎやかしを配置
				game_score_mob_count++;
				if ( time_extend_mode == 1 )
				{
					SetCharacterEX( new Vec3( Hell_randInt( 0, getMapWidth( ) ), 3090, 0 ), cast( int )Character.CHRTYPE.MOB1, 0 );
				}
				else 
				{
					SetCharacterEX( new Vec3( Hell_randInt( 0, getMapWidth( ) ), 3090, 0 ), cast( int )Character.CHRTYPE.MOB1, 1 );
				}
			}
			if ( ( game_score_item_count > 0 ) && ( ( game_score_item_count % 30 ) == 0 ) )
			{
				//にぎやかしを配置
				game_score_mob_count++;
				if ( time_extend_mode == 1 )
				{
					SetCharacterEX( new Vec3( Hell_randInt( 0, getMapWidth( ) ), 3090, 0 ), cast( int )Character.CHRTYPE.MOB1, 0 );
				}
				else 
				{
					SetCharacterEX( new Vec3( Hell_randInt( 0, getMapWidth( ) ), 3090, 0 ), cast( int )Character.CHRTYPE.MOB1, 5 );
				}	
			}
			break;
		case REQEST_CODE.REQEST_SCOER_UP_ITEM3GET:
			//同じアイテムを３つ連続で取った
			//スコアの加算処理
			game_score = game_score + ( 3500 );
			bouns_item_get = bouns_item_get + ( 3500 );
			//エフェクト3の生成
			charidx = CHARACTER_MAX - 1;
			character[charidx].init( this, new Vec3( x, y, 0 ), Character.CHRTYPE.EFFECT3 );
			character[charidx].set_param( 3500 );
			character[charidx].set_buffer( 2, 2 );

			//にぎやかしを配置
			game_score_mob_count++;
			if ( time_extend_mode == 1 )
			{
				SetCharacterEX( new Vec3( Hell_randInt( 0, getMapWidth( ) ), 3090, 0 ), cast( int )Character.CHRTYPE.MOB1, 0 );
			}
			else 
			{
				SetCharacterEX( new Vec3( Hell_randInt( 0, getMapWidth( ) ), 3090, 0 ), cast( int )Character.CHRTYPE.MOB1, 2 );
			}
			break;
		case REQEST_CODE.REQEST_SCOER_UP_ENEMYGET:
			//敵を倒した
			//スコアの加算処理
			enemy_get_count++;
			if ( enemy_get_count > 6 )
			{
				enemy_get_count = 6;
			}

			game_score = game_score + ( enemy_get_count * 800 );
			bouns_enemy_get = bouns_enemy_get + ( enemy_get_count * 800 );
			//エフェクト3の生成
			charidx = CHARACTER_MAX - 1;
			character[charidx].init( this, new Vec3( x, y, 0 ), Character.CHRTYPE.EFFECT3 );
			character[charidx].set_param( ( enemy_get_count * 800 ) );
			character[charidx].set_buffer( 2, 3 );
			
			if ( arcade_mode == 1 )
			{
				time_extend_count++;
				if ( time_extend_count >= 10 )
				{
					time_extend_count = 0;
					game_time_count = game_time_count + ( 60 * 10 );		//ゲーム終了までの残り時間 30秒
					//エフェクト3の生成
					charidx = CHARACTER_MAX - 1;
					character[charidx].init( this, new Vec3( x, y, 0 ), Character.CHRTYPE.EFFECT3 );
					character[charidx].set_param( 10 );
					character[charidx].set_buffer( 2, 5 );
				}
			}

			if ( time_extend_mode == 1 )
			{
				SetCharacterEX( new Vec3( Hell_randInt( 0, getMapWidth( ) ), 3090, 0 ), cast( int )Character.CHRTYPE.MOB1, 0 );
			}
			break;
		case REQEST_CODE.REQEST_SCOER_COUNT_CLAER:
			//スコア倍率のクリア
			game_score_count = 0;
			break;
		case REQEST_CODE.REQEST_EFFECT1:
			//エフェクト１の生成
			SetCharacter( new Vec3( x, y, 0 ), cast( int )Character.CHRTYPE.EFFECT1 );
			break;
		case REQEST_CODE.REQEST_EFFECT2:
			//エフェクト2の生成
			for ( i = 0; i < 10; i++ )
			{
				SetCharacter( new Vec3( x, y, 0 ), cast( int )Character.CHRTYPE.EFFECT2 );
			}
			break;
		case REQEST_CODE.REQEST_EFFECT3:
			//エフェクト3の生成
//			charidx = SetCharacter( new Vec3( x, y, 0 ), cast( int )Character.CHRTYPE.EFFECT3 );
//			if ( ( charidx != -1 ) )
//			{
//				character[charidx].set_param( game_score_count * 50 );
//			}
			charidx = CHARACTER_MAX - 1;
			character[charidx].init( this, new Vec3( x, y, 0 ), Character.CHRTYPE.EFFECT3 );
			character[charidx].set_param( 0 );
			character[charidx].set_buffer( 2, 0 );
			break;
		case REQEST_CODE.REQEST_ENEMY_DEL:

			iSceneStatus = SCENE.PLAYER_MISSWAIT;
			player_misswait_count = 120;
			powerup_count = 0;	//パワーアップクリア
			//にぎやかしを配置
			game_score_mob_count++;
			if ( time_extend_mode == 1 )
			{
				SetCharacterEX( new Vec3( Hell_randInt( 0, getMapWidth( ) ), 3090, 0 ), cast( int )Character.CHRTYPE.MOB1, 0 );
			}
			else 
			{
				SetCharacterEX( new Vec3( Hell_randInt( 0, getMapWidth( ) ), 3090, 0 ), cast( int )Character.CHRTYPE.MOB1, 3 );
			}
			break;
		case REQEST_CODE.REQEST_POWER_UP:
			//パワーアップ
			if ( arcade_mode == 1 )	//アーケードモード
			{
			}
			else 
			{
				powerup_count_max = ( 60 * 5 );
			}
			
			powerup_count_start_max = powerup_count_max;
			powerup_count = powerup_count_max;
			//敵を倒せるようにする
			for ( i = cast( int )Character.CHRTYPE.ENEMY_START; i < cast( int )Character.CHRTYPE.ENEMY_END; i++ )
			{
				set_character_buffer( cast( Character.CHRTYPE )i, 2, cast( int )1 );
			}
			Hell_playWAV( "powerup", 0, -1 );
			
			//にぎやかしを配置
			game_score_mob_count++;
			if ( time_extend_mode == 1 )
			{
				SetCharacterEX( new Vec3( Hell_randInt( 0, getMapWidth( ) ), 3090, 0 ), cast( int )Character.CHRTYPE.MOB1, 0 );
			}
			else 
			{
				SetCharacterEX( new Vec3( Hell_randInt( 0, getMapWidth( ) ), 3090, 0 ), cast( int )Character.CHRTYPE.MOB1, 4 );
			}
			break;
		case REQEST_CODE.REQEST_ENEMY_CREATE:
			//敵の生成
			charidx = SetCharacter( new Vec3( getMapWidth( ) / 2, 3136 + 170 , 0 ), cast( int )Character.CHRTYPE.ENEMY1 );
			if ( ( charidx != -1 ) )
			{
				character[charidx].set_param( param1 );	//パラメータの追加
			}
			break;
		case REQEST_CODE.REQEST_ENEMY_GETWAIT:
			//敵を倒した時のウェイト
			iSceneStatus = SCENE.ENEMY_GETWAIT;
			enemy_getwait_count = 15;
			break;
		case REQEST_CODE.REQEST_SCOER_UP_NONSTOP:
			//走り続けたボーナス
			//スコアの加算処理
			game_score = game_score + ( 2000 );
			itemget = 1;				//プレイヤーがアイテムを取得した
			//エフェクト3の生成
			charidx = CHARACTER_MAX - 1;
			character[charidx].init( this, new Vec3( x, y, 0 ), Character.CHRTYPE.EFFECT3 );
			character[charidx].set_param( 2000 );
			character[charidx].set_buffer( 2, 4 );

			if ( time_extend_mode == 1 )
			{
				SetCharacterEX( new Vec3( Hell_randInt( 0, getMapWidth( ) ), 3090, 0 ), cast( int )Character.CHRTYPE.MOB1, 0 );
			}
			break;
		default:
			break;
		}
	}

	//-----------------------------------------------------------------------------
	//	プレイヤーワープ処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void player_warp_proc( )
	{
		int i;
		int ch_idx;
		
		if ( cast( int )player_warp_counter > 0 )
		{
			player_warp_counter = player_warp_counter - game_speed;
			if ( player_warp_houkou == 0 )
			{
//				map_rotate = map_rotate - 6;
				map_rotate = map_rotate - ( 3 * game_speed );
			}
			else 
			{
//				map_rotate = map_rotate + 6;
				map_rotate = map_rotate + ( 3 * game_speed );
			}
			map_size = 0;
			
			map1.setMapRotate( map_rotate );
			map1.setMapSize( map_size );
			map2.setMapRotate( map_rotate );
			map2.setMapSize( map_size );

			for ( i = cast( int )Character.CHRTYPE.EVENT_START; i < cast( int )Character.CHRTYPE.MAX; i++ )
			{
				character_setrotate( i );
			}
		}
		else 
		{
			if ( player_warp_houkou == 0 )
			{
//				map_rotate = player_warp_start  - 179.5 - ( map_rotate_speed * game_speed );	//回転演出開始時の角度を保存
				map_rotate = player_warp_start  - 180;	//回転演出開始時の角度を保存
//				map_rotate = map_rotate - ( map_rotate_speed * game_speed );
//				map_rotate = map_rotate + 1;
			}
			else 
			{
//				map_rotate = player_warp_start  + 179.5 + ( map_rotate_speed * game_speed );	//回転演出開始時の角度を保存
				map_rotate = player_warp_start  + 180;	//回転演出開始時の角度を保存
//				map_rotate = map_rotate + ( map_rotate_speed * game_speed );
//				map_rotate = map_rotate - 1;
			}
			iSceneStatus = SCENE.MAIN;
			player_warp_counter = 0;
			//プレイヤーを半周移動
			ch_idx = get_character_index( cast( int )Character.CHRTYPE.PLAYER1, 0 );
			if ( ch_idx != -1 )
			{
				//半周移動
				character[ch_idx].position.x = character[ch_idx].position.x + ( getMapWidth( ) / 2 );
			}
			
			map1.setMapRotate( map_rotate );
			map1.setMapSize( map_size );
			map2.setMapRotate( map_rotate );
			map2.setMapSize( map_size );
		}
	}
	
	//-----------------------------------------------------------------------------
	//	敵を倒した時のウェイト
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void enemy_getwait_proc( )
	{
		int i;
		
		if ( enemy_getwait_count > 0 )
		{
			enemy_getwait_count--;
		}
		else 
		{
			iSceneStatus = SCENE.MAIN;
			enemy_getwait_count = 0;
		}
	}
	//-----------------------------------------------------------------------------
	//	敵を倒した時のウェイト
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void player_misswait_proc( )
	{
		int i;
		
		if ( player_misswait_count > 0 )
		{
			player_misswait_count--;
		}
		else 
		{
			iSceneStatus = SCENE.MAIN;
			player_misswait_count = 0;

			//敵の全削除
			for ( i = cast( int )Character.CHRTYPE.ENEMY_START; i < cast( int )Character.CHRTYPE.ENEMY_END; i++ )
			{
				character_destroy( cast( Character.CHRTYPE )i );
			}
			for ( i = 0; i < 4; i++ )
			{
				enemysetinfo[i] = 0;	//アイテムの配置情報
				enemysetinfo[i+5] = 0;	//アイテムの配置情報
			}
			enemyset_counter = 60;		//敵配置までのカウンター
			enemyset_num = 3;			//敵配置数
		}
	}
	
}


