﻿/********************************************************************************/
/* 	map.d																		*/
/*------------------------------------------------------------------------------*/
/*	製作		D.K（あるふぁ～秘密基地）										*/
/*	製作開始	2008/05/22														*/
/*	MAIL		dk@red.interq.or.jp												*/
/*	URL			http://maglog.jp/alpha-secret-base/								*/
/*																				*/
/*	このソースは「やわらかライセンス」の元で配布されています。					*/
/*-更新履歴---------------------------------------------------------------------*/
/*	2008/05/22	初版															*/
/*-その他-----------------------------------------------------------------------*/
/*	なし																		*/
/********************************************************************************/

private import gamecore;
private import hell2;
private import boot;
private import actor;
private import vector;
private import keypad;

private import character;

private import fmfloader;

//********************************************************************************
// マップクラス
//********************************************************************************


class Map
{

	Layer2D layer_data; // 地形情報
	GameMain gamemain;
	Keypad keypad;

	int bg_disp;		//背景の表示有無
	int param;			//描画順
	
	float map_rotate;
	float map_position;
	float map_speed;

	this( )
	{
	}
	
	//-----------------------------------------------------------------------------
	//	初期化
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void init( GameMain gamemain, Layer2D layer )
	{
		this.keypad = null;
		this.gamemain = gamemain;
		this.layer_data = layer;
		this.bg_disp = 0;
		this.map_rotate = 0;
		this.map_position = 0;
		this.param = 0;			//描画順

//		this.keypad = new Keypad();
		this.keypad = gamemain.keypad;
	}
	
	//-----------------------------------------------------------------------------
	//	マップの移動
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void move( )
	{
		if(keypad.isPressLeft())
		{
		}
		else if(keypad.isPressRight())
		{
		}
		
	}
	//-----------------------------------------------------------------------------
	//	マップの情報を設定
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: Vec3：位置情報
	//-----------------------------------------------------------------------------
	void setMapRotate( float rotate )
	{
		map_rotate = rotate;
	}
	void setMapSize( float size )
	{
		map_position = size;
	}
	
	//-----------------------------------------------------------------------------
	//	マップの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void draw( )
	{
		int x = 0;
		int y = 0;
		
		int r = 255;
		int g = 255;
		int b = 255;
		int a = 64;
		
		if ( gamemain.powerup_count > 0 )
		{
/*
			r = 255;
			g = 128;
			b = 128;
			a = 128;
			if ( gamemain.powerup_count < 120 )
			{
				r = 255;
				g = 128 + cast( int )( 120 - gamemain.powerup_count ) * 1;
				b = 128 + cast( int )( 120 - gamemain.powerup_count ) * 1;
				a = 128 - cast( int )( 120 - gamemain.powerup_count ) * 2;
				if ( a < 64 )
				{
					a = 64;
				}
			}
*/
			r = 128;                                                                  /*【変更05_0001】255→128に変更*/
			g = 255;                                                                  /*【変更05_0002】128→255に変更*/
			b = 128;
			a = 128;
			if ( gamemain.powerup_count < 120 )
			{
				r = 128 + cast( int )( 120 - gamemain.powerup_count ) * 1;            /*【変更05_0003】255固定→128から時間で増えるように変更*/
				g = 255;                                                              /*【変更05_0004】128から時間で増える→255固定に変更*/
				b = 128 + cast( int )( 120 - gamemain.powerup_count ) * 1;
				a = 128 - cast( int )( 120 - gamemain.powerup_count ) * 2;
				if ( a < 64 )
				{
					a = 64;
				}
			}
		}

		switch( param )
		{
		case 1:
			Hell_setAlpha(HELL_ALPHA_NORMAL);
			Hell_drawTextureEx("sora4"
				, 320, 240
				, 0
				, 0
				, 1024, 1024
				, 1.0 , 1.0
				, 0
				,r,g,b,255 );
			if ( gamemain.bak3_alpha == 0 )
			{
				Hell_setAlpha(HELL_ALPHA_ADD);
			}
			else 
			{
				Hell_setAlpha(HELL_ALPHA_NORMAL);
			}
			Hell_drawTextureEx("sora3"
				, 320, 240
				, 0
				, 0
				, 1024, 1024
				, 1.0 , 1.0
				, map_rotate/4
				,r,g,b,128 );
			if ( gamemain.bak2_alpha == 0 )
			{
				Hell_setAlpha(HELL_ALPHA_ADD);
			}
			else 
			{
				Hell_setAlpha(HELL_ALPHA_NORMAL);
			}
			Hell_drawTextureEx("sora2"
				, 320, 240
				, 0
				, 0
				, 1024, 1024
				, 1.0 , 1.0
				, map_rotate/3
				,r,g,b,128 );
			if ( gamemain.bak1_alpha == 0 )
			{
				Hell_setAlpha(HELL_ALPHA_ADD);
			}
			else 
			{
				Hell_setAlpha(HELL_ALPHA_NORMAL);
			}
			Hell_drawTextureEx("sora1"
				, 320, 240
				, 0
				, 0
				, 1024, 1024
				, 1.0 , 1.0
				, map_rotate/2
				,r,g,b,a );
			break;
		case 2:
			if ( gamemain.bak1_alpha == 0 )
			{
				Hell_setAlpha(HELL_ALPHA_ADD);
			}
			else 
			{
				Hell_setAlpha(HELL_ALPHA_NORMAL);
			}
			Hell_drawTextureEx("sora1"
				, 320, 240
				, 0
				, 0
				, 1024, 1024
				, 1.0 , 1.0
				, map_rotate/2
				,r,g,b,a );

			Hell_setAlpha(HELL_ALPHA_NORMAL);
			Hell_drawTextureEx("hosi"
				, 320, 240
				, 0
				, 0
				, 1024, 1024
				, 1.0 , 1.0
				, map_rotate
				,r,g,b,255 );
			Hell_drawTextureEx("ana"
				, 320, 240
				, 0
				, 0
				, 1024, 1024
				, 1.0 , 1.0
				, map_rotate
				,r,g,b,255 );
			break;
		default:
			break;
		}
/*
// for debug code start
Hell_drawFont( std.string.toString( cast( int )map_rotate )
             , cast( int )320
             , cast( int )240
             , 1 , 255,255,255 );
*/
		if ( bg_disp != 0 )
		{
		}
/*	
		for ( x = 0; x < layer_data.width; x++ )
		{
			for ( y = 0; y < layer_data.height; y++ )
			{
				int x1 = ( x * layer_data.chip_width ) + ( layer_data.chip_width / 2 );
				int x2 = ( x * layer_data.chip_width ) - ( layer_data.chip_width / 2 );
				int y1 = ( y * layer_data.chip_height ) + ( layer_data.chip_height / 2 );
				int y2 = ( y * layer_data.chip_height ) - ( layer_data.chip_height / 2 );;

				int id = layer_data.get(x, y);
				if ( id < 255 )
				{
					if (
					     ( gamemain.view_point_x < x1 )
					  && ( ( gamemain.view_point_x + gamemain.getScreenWidth( ) ) > x2  )
					  && ( gamemain.view_point_y < y1 )
					  && ( ( gamemain.view_point_y + gamemain.getScreenHeight( ) ) > y2 )
					   )
					{
						Hell_drawTexture("map1"
							, ( ( x * layer_data.chip_width ) - ( layer_data.chip_width / 2 ) ) - gamemain.view_point_x
							, ( ( y * layer_data.chip_height ) - ( layer_data.chip_height / 2 ) ) - gamemain.view_point_y
							, ( id % 16 ) * layer_data.chip_width
							, ( id / 16 ) * layer_data.chip_height
							, layer_data.chip_width , layer_data.chip_height
							, 1.0 , 1.0 );
					}
				}
			}
		}
*/
	}
	
	//-----------------------------------------------------------------------------
	//	背景表示の設定
	//-----------------------------------------------------------------------------
	//	引	数: int disp:表示の有無
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void set_bg( int disp )
	{
		bg_disp = disp;
	}
	
	//-----------------------------------------------------------------------------
	//	ゲームスピードの設定
	//-----------------------------------------------------------------------------
	//	引	数: float speed:ゲームスピード
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void setGameSpeed( float speed )
	{
		map_speed = speed;
	}
	//-----------------------------------------------------------------------------
	//	パラメータの設定
	//-----------------------------------------------------------------------------
	//	引	数: int add_param：パラメータ
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void set_param( int add_param )
	{
		param = add_param;					//パラメータ
	}

}

//********************************************************************************
